const C3 = self.C3;

const BEHAVIOR_INFO = {
    id: "piranha305_boomerang",
    Acts: {
      "SetProperties": {
            "forward": (inst) => inst.SetProperties,
            
            "autoScriptInterface": true,
            },
"SetEnabled": {
            "forward": (inst) => inst.SetEnabled,
            
            "autoScriptInterface": true,
            },
"SetReturnMode": {
            "forward": (inst) => inst.SetReturnMode,
            
            "autoScriptInterface": true,
            },
"SetAcceleration": {
            "forward": (inst) => inst.SetAcceleration,
            
            "autoScriptInterface": true,
            },
"SetMaxSpeed": {
            "forward": (inst) => inst.SetMaxSpeed,
            
            "autoScriptInterface": true,
            },
"SetMaxTravelDistance": {
            "forward": (inst) => inst.SetMaxTravelDistance,
            
            "autoScriptInterface": true,
            },
"SetMaxTravelTime": {
            "forward": (inst) => inst.SetMaxTravelTime,
            
            "autoScriptInterface": true,
            },
"SetReturnDelay": {
            "forward": (inst) => inst.SetReturnDelay,
            
            "autoScriptInterface": true,
            },
"SetCheckForSolids": {
            "forward": (inst) => inst.SetCheckForSolids,
            
            "autoScriptInterface": true,
            },
"Throw": {
            "forward": (inst) => inst.Throw,
            
            "autoScriptInterface": true,
            },
"ThrowToPosition": {
            "forward": (inst) => inst.ThrowToPosition,
            
            "autoScriptInterface": true,
            },
"ThrowFromObject": {
            "forward": (inst) => inst.ThrowFromObject,
            
            "autoScriptInterface": true,
            },
"ThrowToPositionFromObject": {
            "forward": (inst) => inst.ThrowToPositionFromObject,
            
            "autoScriptInterface": true,
            },
"Return": {
            "forward": (inst) => inst.Return,
            
            "autoScriptInterface": true,
            }
    },
    Cnds: {
      "IsThrown": {
            "forward": (inst) => inst.IsThrown,
            
            "autoScriptInterface": true,
          },
"IsReturning": {
            "forward": (inst) => inst.IsReturning,
            
            "autoScriptInterface": true,
          },
"IsDelayingReturn": {
            "forward": (inst) => inst.IsDelayingReturn,
            
            "autoScriptInterface": true,
          },
"HasReturnObject": {
            "forward": (inst) => inst.HasReturnObject,
            
            "autoScriptInterface": true,
          },
"OnSolidHit": {
            "forward": (inst) => inst.OnSolidHit,
            
            "autoScriptInterface": true,
          },
"OnReturn": {
            "forward": (inst) => inst.OnReturn,
            
            "autoScriptInterface": true,
          },
"OnReturnComplete": {
            "forward": (inst) => inst.OnReturnComplete,
            
            "autoScriptInterface": true,
          },
"OnThrow": {
            "forward": (inst) => inst.OnThrow,
            
            "autoScriptInterface": true,
          },
"OnDelay": {
            "forward": (inst) => inst.OnDelay,
            
            "autoScriptInterface": true,
          },
"IsMoving": {
            "forward": (inst) => inst.IsMoving,
            
            "autoScriptInterface": true,
          },
"IsEnabled": {
            "forward": (inst) => inst.IsEnabled,
            
            "autoScriptInterface": true,
          }
    },
    Exps: {
      "MovingAngle": {
            "forward": (inst) => inst.MovingAngle,
            
            "autoScriptInterface": true,
          },
"CurrentSpeed": {
            "forward": (inst) => inst.CurrentSpeed,
            
            "autoScriptInterface": true,
          },
"CurrentDistance": {
            "forward": (inst) => inst.CurrentDistance,
            
            "autoScriptInterface": true,
          },
"CurrentTime": {
            "forward": (inst) => inst.CurrentTime,
            
            "autoScriptInterface": true,
          },
"ThrownAngle": {
            "forward": (inst) => inst.ThrownAngle,
            
            "autoScriptInterface": true,
          },
"ThrowerUID": {
            "forward": (inst) => inst.ThrowerUID,
            
            "autoScriptInterface": true,
          },
"HitPointX": {
            "forward": (inst) => inst.HitPointX,
            
            "autoScriptInterface": true,
          },
"HitPointY": {
            "forward": (inst) => inst.HitPointY,
            
            "autoScriptInterface": true,
          }
    },
  };

const camelCasedMap = new Map();

function camelCasify(str) {
  // If the string is already camelCased, return it
  if (camelCasedMap.has(str)) {
    return camelCasedMap.get(str);
  }
  // Replace any non-valid JavaScript identifier characters with spaces
  let cleanedStr = str.replace(/[^a-zA-Z0-9$_]/g, " ");

  // Split the string on spaces
  let words = cleanedStr.split(" ").filter(Boolean);

  // Capitalize the first letter of each word except for the first one
  for (let i = 1; i < words.length; i++) {
    words[i] = words[i].charAt(0).toUpperCase() + words[i].substring(1);
  }

  // Join the words back together
  let result = words.join("");

  // If the first character is a number, prepend an underscore
  if (!isNaN(parseInt(result.charAt(0)))) {
    result = "_" + result;
  }

  camelCasedMap.set(str, result);

  return result;
}

C3.Behaviors[BEHAVIOR_INFO.id] = class extends C3.SDKBehaviorBase {
  constructor(opts) {
    super(opts);
  }

  Release() {
    super.Release();
  }
};
const B_C = C3.Behaviors[BEHAVIOR_INFO.id];
B_C.Type = class extends C3.SDKBehaviorTypeBase {
  constructor(objectClass) {
    super(objectClass);
  }

  Release() {
    super.Release();
  }

  OnCreate() {}
};

//====== SCRIPT INTERFACE ======
const map = new WeakMap();

function getScriptInterface(parentClass, map) {
  return class extends parentClass {
    constructor() {
      super();
      map.set(this, parentClass._GetInitInst().GetSdkInstance());
    }
  };
}


const scriptInterface = getScriptInterface(self.IBehaviorInstance, map);

// extend script interface with plugin actions
Object.keys(BEHAVIOR_INFO.Acts).forEach((key) => {
  const ace = BEHAVIOR_INFO.Acts[key];
  if (!ace.autoScriptInterface) return;
  if (ace.isAsync) {
    scriptInterface.prototype[camelCasify(key)] = async function (...args) {
      const sdkInst = map.get(this);
      await B_C.Acts[camelCasify(key)].call(sdkInst, ...args);
    };
  } else {
    scriptInterface.prototype[camelCasify(key)] = function (...args) {
      const sdkInst = map.get(this);
      B_C.Acts[camelCasify(key)].call(sdkInst, ...args);
    };
  }
});

const addonTriggers = [];

// extend script interface with plugin conditions
Object.keys(BEHAVIOR_INFO.Cnds).forEach((key) => {
  const ace = BEHAVIOR_INFO.Cnds[key];
  if (!ace.autoScriptInterface || ace.isStatic || ace.isLooping) return;
  if (ace.isTrigger) {
    scriptInterface.prototype[camelCasify(key)] = function (callback, ...args) {
      const callbackWrapper = () => {
        const sdkInst = map.get(this);
        if (B_C.Cnds[camelCasify(key)].call(sdkInst, ...args)) {
          callback();
        }
      };
      this.addEventListener(key, callbackWrapper, false);
      return () => this.removeEventListener(key, callbackWrapper, false);
    };
  } else {
    scriptInterface.prototype[camelCasify(key)] = function (...args) {
      const sdkInst = map.get(this);
      return B_C.Cnds[camelCasify(key)].call(sdkInst, ...args);
    };
  }
});

// extend script interface with plugin expressions
Object.keys(BEHAVIOR_INFO.Exps).forEach((key) => {
  const ace = BEHAVIOR_INFO.Exps[key];
  if (!ace.autoScriptInterface) return;
  scriptInterface.prototype[camelCasify(key)] = function (...args) {
    const sdkInst = map.get(this);
    return B_C.Exps[camelCasify(key)].call(sdkInst, ...args);
  };
});
//====== SCRIPT INTERFACE ======

//============ ACES ============
B_C.Acts = {};
B_C.Cnds = {};
B_C.Exps = {};
Object.keys(BEHAVIOR_INFO.Acts).forEach((key) => {
  const ace = BEHAVIOR_INFO.Acts[key];
  B_C.Acts[camelCasify(key)] = function (...args) {
    if (ace.forward) ace.forward(this).call(this, ...args);
    else if (ace.handler) ace.handler.call(this, ...args);
  };
});
Object.keys(BEHAVIOR_INFO.Cnds).forEach((key) => {
  const ace = BEHAVIOR_INFO.Cnds[key];
  B_C.Cnds[camelCasify(key)] = function (...args) {
    if (ace.forward) return ace.forward(this).call(this, ...args);
    if (ace.handler) return ace.handler.call(this, ...args);
  };
  if (ace.isTrigger && ace.autoScriptInterface) {
    addonTriggers.push({
      method: B_C.Cnds[camelCasify(key)],
      id: key,
    });
  }
});
Object.keys(BEHAVIOR_INFO.Exps).forEach((key) => {
  const ace = BEHAVIOR_INFO.Exps[key];
  B_C.Exps[camelCasify(key)] = function (...args) {
    if (ace.forward) return ace.forward(this).call(this, ...args);
    if (ace.handler) return ace.handler.call(this, ...args);
  };
});
//============ ACES ============

const BOOMERANG_STATE = {
  IDLE: 0,
  THROWN: 1,
  DELAY: 2,
  RETURNING: 3,
};

function getInstanceJs(parentClass, scriptInterface, addonTriggers, C3) {
  return class extends parentClass {
    constructor(inst, properties) {
      super(inst);

      this.enabled = false;
      this.returnMode = 0;
      this.acceleration = 0;
      this.maxSpeed = 0;
      this.maxTravelDistance = 0;
      this.maxTravelTime = 0;
      this.returnDelay = 0;
      this.checkForSolids = false;

      if (properties) {
        this.enabled = properties[0];
        this.returnMode = properties[1];
        this.acceleration = properties[2];
        this.maxSpeed = properties[3];
        this.maxTravelDistance = properties[4];
        this.maxTravelTime = properties[5];
        this.returnDelay = properties[6];
        this.checkForSolids = properties[7];
      }

      this._state = BOOMERANG_STATE.IDLE;
      this._speed = 0;
      this._acceleration = 0;
      this._dx = 0;
      this._dy = 0;
      this._stepSize = 2; //TODO: add step size property?

      this._distance = 0;
      this._travelTime = 0;
      this._returnDelay = 0;
      this._throwAngle = 0;
      this._thrower = null;
      this._throwerUID = -1;
      this._returnX = 0
      this._returnY = 0;

      this._movingAgnle = 0;
      this._hitX = -1;
      this._hitY = -1;
    }

    SetProperties(enabled, returnMode, acceleration, maxSpeed, maxTravelDistance, maxTravelTime, returnDelay, checkForSolids) {
      this.enabled = enabled;
      this.returnMode = returnMode;
      this.acceleration = acceleration;
      this.maxSpeed = maxSpeed;
      this.maxTravelDistance = maxTravelDistance;
      this.maxTravelTime = maxTravelTime;
      this.returnDelay = returnDelay;
      this.checkForSolids = checkForSolids;
    }

    SetEnabled(enabled) {
      this.enabled = enabled;
    }

    SetReturnMode(returnMode) {
      this.returnMode = returnMode;
    }
    
    SetAcceleration(acceleration) {
      this.acceleration = acceleration;
    }

    SetMaxSpeed(maxSpeed) {
      this.maxSpeed = maxSpeed;
    }

    SetMaxTravelDistance(maxTravelDistance) {
      this.maxTravelDistance = maxTravelDistance;
    }

    SetMaxTravelTime(maxTravelTime) {
      this.maxTravelTime = maxTravelTime;
    }

    SetReturnDelay(returnDelay) {
      this.returnDelay = returnDelay;
    }

    SetCheckForSolids(checkForSolids) {
      this.checkForSolids = checkForSolids;
    }

    Throw(angle) {
      if(!this.enabled || !this._state === BOOMERANG_STATE.IDLE) {
        return;
      }

      this._state = BOOMERANG_STATE.THROWN;
      this._speed = 0;
      this._acceleration = this.acceleration;
      this._dx = 0;
      this._dy = 0;
      this._distance = 0;
      this._travelTime = 0;
      this._returnDelay = 0;
      this._throwAngle = C3.toRadians(angle);
      this._thrower = null;
      this._throwerUID = -1;

      this._returnX = this.inst.GetWorldInfo().GetX();
      this._returnY = this.inst.GetWorldInfo().GetY();

      this.Trigger(C3.Behaviors.piranha305_boomerang.Cnds.OnThrow);
      this._StartTicking();
    }

    ThrowToPosition(x, y) {
      if(!this.enabled || !this._state === BOOMERANG_STATE.IDLE) {
        return;
      }

      const wi = this._inst.GetWorldInfo();
      const angle = C3.angleTo(wi.GetX(), wi.GetY(), x, y);
      this.Throw(C3.toDegrees(angle));
    }

    ThrowFromObject(angle, object) {
      if(!this.enabled || !this._state === BOOMERANG_STATE.IDLE) {
        return;
      }

      this._state = BOOMERANG_STATE.THROWN;
      this._speed = 0;
      this._acceleration = this.acceleration;
      this._dx = 0;
      this._dy = 0;;
      this._distance = 0;
      this._travelTime = 0;
      this._returnDelay = 0;
      this._throwAngle = C3.toRadians(angle);
      this._thrower = object.GetFirstPicked();
      this._throwerUID = this._thrower.GetUID();

      this._returnX = this._inst.GetWorldInfo().GetX();
      this._returnY = this._inst.GetWorldInfo().GetY();

      this.Trigger(C3.Behaviors.piranha305_boomerang.Cnds.OnThrow);
      this._StartTicking();
    }

    ThrowToPositionFromObject(x, y, object) {
      if(!this.enabled || !this._state === BOOMERANG_STATE.IDLE) {
        return;
      }

      const wi = this._inst.GetWorldInfo();
      const angle = C3.toDegrees(C3.angleTo(wi.GetX(), wi.GetY(), x, y));
      this.ThrowFromObject(angle, object);
    }

    Return(waitForDelay) {
      if(!this.enabled || !this._state === BOOMERANG_STATE.THROWN) {
        return;
      }

      if(waitForDelay) {
        this._state = BOOMERANG_STATE.DELAY;
        this.Trigger(C3.Behaviors.piranha305_boomerang.Cnds.OnDelay);
      }
      else {
        this._state = BOOMERANG_STATE.RETURNING;
        this._dx = 0;
        this._dy = 0;
        this.Trigger(C3.Behaviors.piranha305_boomerang.Cnds.OnReturn);
      }
    }

    Tick() {
      if(!this.enabled) {
        return;
      }

      switch(this._state) {
        case BOOMERANG_STATE.IDLE:
          this._StopTicking();
          break;
        case BOOMERANG_STATE.THROWN:
          this.TickThrown();
          break;
        case BOOMERANG_STATE.DELAY:
          this.TickDelay();
          break;
        case BOOMERANG_STATE.RETURNING:
          this.TickReturn();
          break;
      }
    }

    TickThrown() {
      const dt = this._runtime.GetDt(this._inst);
      const wi = this._inst.GetWorldInfo();
      this._speed = C3.distanceTo(0, 0, this._dx, this._dy);
      this._speed += this._acceleration * dt;
      this._travelTime += dt;

      //Reset Hit Position
      this._hitX = -1;
      this._hitY = -1;

      let xacc = Math.cos(this._throwAngle) * this._acceleration;
      let yacc = Math.sin(this._throwAngle) * this._acceleration;

      if (this._speed < 0) {
        this._speed = 0;
        xacc = 0;
        yacc = 0;
      }

      this._dx = Math.cos(this._throwAngle) * this._speed;
      this._dy = Math.sin(this._throwAngle) * this._speed;
      this._movingAgnle = C3.toDegrees(this._throwAngle);

      if (this._dx !== 0 || this._dy !== 0) {
        const mx = this._dx * dt + 0.5 * xacc * dt * dt;
        const my = this._dy * dt + 0.5 * yacc * dt * dt;
        const stepDistance = C3.distanceTo(0, 0, mx, my);
        this._MoveBy(mx, my, stepDistance);
        this._distance += stepDistance;
        wi.SetBboxChanged();
      }

      //Time Travelled
      if (this.returnMode === 0) { 
        // return when max time reached
        if (this._travelTime >= this.maxTravelTime) {
          this._state = BOOMERANG_STATE.DELAY;
          this.Trigger(C3.Behaviors.piranha305_boomerang.Cnds.OnDelay);
        }
       
      } 
      // Distance Travlled
      else if (this.returnMode === 1) { 
         // return when max distance reached
         if (this._distance >= this.maxTravelDistance) {
          this._state = BOOMERANG_STATE.DELAY;
          this.Trigger(C3.Behaviors.piranha305_boomerang.Cnds.OnDelay);
        }
      } 
    }

    TickDelay() {
      const dt = this._runtime.GetDt(this._inst);
      this._returnDelay += dt;

      if (this._returnDelay >= this.returnDelay) {
        this._state = BOOMERANG_STATE.RETURNING;
        this._dx = 0;
        this._dy = 0;
        this.Trigger(C3.Behaviors.piranha305_boomerang.Cnds.OnReturn);
      }
    }

    TickReturn() {
      if(this._thrower) {
        const _throwerWi = this._thrower.GetWorldInfo();
        this._returnX = _throwerWi.GetX();
        this._returnY = _throwerWi.GetY();
      }

      const dt = this._runtime.GetDt(this._inst);
      const wi = this._inst.GetWorldInfo();
      const angle = C3.angleTo(wi.GetX(), wi.GetY(), this._returnX, this._returnY);
      this._speed = C3.distanceTo(0, 0, this._dx, this._dy);
      this._speed += this._acceleration * dt;

      let xacc = Math.cos(angle) * this._acceleration;
      let yacc = Math.sin(angle) * this._acceleration;

      if (this._speed < 0) {
        this._speed = 0;
        xacc = 0;
        yacc = 0;
      }

      this._dx = Math.cos(angle) * this._speed;
      this._dy = Math.sin(angle) * this._speed;
      this._movingAgnle = C3.toDegrees(angle);

      if (this._dx !== 0 || this._dy !== 0) {
        const mx = this._dx * dt + 0.5 * xacc * dt * dt;
        const my = this._dy * dt + 0.5 * yacc * dt * dt;
        const stepDistance = C3.distanceTo(0, 0, mx, my);
        this._MoveBy(mx, my, stepDistance);
        wi.SetBboxChanged();
      }

      const stoppingDistance = 0.5 * this._speed * this._speed / this._acceleration * 1.0001;
      const isWithinStoppingDistance = C3.distanceSquared(wi.GetX(), wi.GetY(), this._returnX, this._returnY) <= stoppingDistance;
      if(isWithinStoppingDistance) {
        this._state = BOOMERANG_STATE.IDLE;
        wi.SetXY(this._returnX, this._returnY);
        wi.SetBboxChanged();
        this.Trigger(C3.Behaviors.piranha305_boomerang.Cnds.OnReturnComplete);
      }
    }

    _MoveBy(mx, my, stepDistance){
      const wi = this._inst.GetWorldInfo();
      const startX = wi.GetX();
      const startY = wi.GetY();
      const endX = startX + mx;
      const endY = startY + my;
      const angle = C3.angleTo(0, 0, endX, endY);

      const stepX = Math.cos(angle) * this._stepSize;
      const stepY = Math.sin(angle) * this._stepSize;
      const steps = Math.floor(stepDistance / this._stepSize);

      for (let i = 0; i < steps; i++) {
        wi.SetXY(startX + stepX * i, startY + stepY * i);
        wi.SetBboxChanged();
        if(this._CheckForSolids()) {
          this.Trigger(C3.Behaviors.piranha305_boomerang.Cnds.OnSolidHit);
          return;
        }
      }

      wi.SetXY(endX, endY);
      wi.SetBboxChanged();
    }

    _CheckForSolids() {  
      // only check for collision on the thrown not the return
      if(!this.checkForSolids || this._state !== BOOMERANG_STATE.THROWN) {
        return false;
      }

      const collisionEngine = this._runtime.GetCollisionEngine();
      const solid = collisionEngine.TestOverlapSolid(this._inst);
      if(solid) {
        const intersectRect = this._GetIntersectRect(this._inst.GetWorldInfo().GetBoundingBox(), solid.GetWorldInfo().GetBoundingBox());
        this._hitX = intersectRect.midX();
        this._hitY = intersectRect.midY();

        this._state = BOOMERANG_STATE.DELAY;
        this.Trigger(C3.Behaviors.piranha305_boomerang.Cnds.OnDelay);
        return true;
      }

      return false;
    }

    _GetIntersectRect(a, b) {
      const left = Math.max(a.getLeft(), b.getLeft());
      const top = Math.max(a.getTop(), b.getTop());
      const right = Math.min(a.getRight(), b.getRight());
      const bottom = Math.min(a.getBottom(), b.getBottom());
      return new C3.Rect(left, top, right, bottom);
    }

    IsEnabled() { 
      return this.enabled; 
    }

    IsThrown() { 
      return this._state === BOOMERANG_STATE.THROWN; 
    
    }
    IsDelayingReturn() { 
      return this.returnDelay > 0 && this._state === BOOMERANG_STATE.DELAY; 
    }

    IsReturning() { 
      return this._state === BOOMERANG_STATE.RETURNING; 
    }

    HasReturnObject() { 
      return this._thrower !== null; 
    }

    IsMoving() { 
      return this._state === BOOMERANG_STATE.THROWN || this._state === BOOMERANG_STATE.RETURNING; 
    }

    // Triggers 
    OnSolidHit() { return true; }
    OnReturn()   { return true; }
    OnReturnComplete()   { return true; }
    OnThrow()    { return true; }
    OnDelay()    { return true; }

    // Expressions
    MovingAngle() { 
      return this._movingAgnle; 
    }

    CurrentSpeed() {
      return this._speed;
    }

    CurrentDistance() {
      return this._distance;
    }

    CurrentTravelTime() {
      return this._travelTime;
    }

    ThrownAngle() {
      return C3.toDegrees(this._throwAngle);
    }

    ThrowerUID() {
      return this._thrower != null ? this._throwerUID : -1;
    }

    HitPointX() {
      return this._hitX;
    }

    HitPointY() {
      return this._hitY;
    }

    Release() {
      super.Release();
    }

    SaveToJson() {
      return {
        enabled : this.enabled,
        returnMode : this.returnMode,
        acceleration : this.acceleration,
        maxSpeed : this.maxSpeed,
        maxTravelDistance : this.maxTravelDistance,
        maxTravelTime : this.maxTravelTime,
        returnDelay : this.returnDelay,
        checkForSolids : this.checkForSolids,
        state : this._state,
        speed : this._speed,
        acceleration : this._acceleration,
        dx : this._dx,
        dy : this._dy,
        stepSize : this._stepSize,
        distance : this._distance,
        travelTime : this._travelTime,
        returnDelay : this._returnDelay,
        throwAngle : this._throwAngle,
        throwerUID : this._throwerUID,
        returnX : this._returnX,
        returnY : this._returnY,
        movingAngle : this._movingAgnle,
      };
    }

    LoadFromJson(o) {
      this.enabled = o.enabled;
      this.returnMode = o.returnMode;
      this.acceleration = o.acceleration;
      this.maxSpeed = o.maxSpeed;
      this.maxTravelDistance = o.maxTravelDistance;
      this.maxTravelTime = o.maxTravelTime;
      this.returnDelay = o.returnDelay;
      this.checkForSolids = o.checkForSolids;
      this._state = o.state;
      this._speed = o.speed;
      this._acceleration = o.acceleration;
      this._dx = o.dx;
      this._dy = o.dy;
      this._stepSize = o.stepSize;
      this._distance = o.distance;
      this._travelTime = o.travelTime;
      this._returnDelay = o.returnDelay;
      this._throwAngle = o.throwAngle;
      this._throwerUID = o.throwerUID;
      this._returnX = o.returnX;
      this._returnY = o.returnY;
      this._movingAgnle = o.movingAngle;
    }

    Trigger(method) {
      super.Trigger(method);
      const addonTrigger = addonTriggers.find((x) => x.method === method);
      if (addonTrigger) {
        this.GetScriptInterface().dispatchEvent(new C3.Event(addonTrigger.id));
      }
    }

    GetDebuggerProperties() {
      return [
        {
          title: "Piranha305_Boomerang",
          properties: [
            { name: "Enabled", value: this.enabled, readonly: false },
            { name: "State", value: this.GetCurrentStateString(this._state), readonly: true},
            { name: "Return Mode", value: this.returnMode, readonly: false },
            { name: "Acceleration", value: this.acceleration, readonly: false },
            { name: "Max Speed", value: this.maxSpeed, readonly: false },
            { name: "Current Speed", value: this._speed, readonly: true},
            { name: "Max Travel Distance", value: this.maxTravelDistance, readonly: false },
            { name: "Travel Distance", value: this._distance, readonly: true },
            { name: "Max Travel Time", value: this.maxTravelTime, readonly: false },
            { name: "Travel Time", value: this._travelTime, readonly: true },
            { name: "Return Delay", value: this.returnDelay, readonly: false },
            { name: "Check For Solids", value: this.checkForSolids, readonly: false },
            { name: "Throw Angle", value: this._throwAngle, readonly: true },
            { name: "Thrower UID", value: this._throwerUID, readonly: true },
            { name: "Return X", value: this._returnX, readonly: true },
            { name: "Return Y", value: this._returnY, readonly: true }
          ],
        },
      ];
    }

    GetCurrentStateString(state) {
      switch (state) {
        case BOOMERANG_STATE.IDLE:
          return "Idle";
        case BOOMERANG_STATE.THROWN:
          return "Thrown";
        case BOOMERANG_STATE.DELAY:
          return "Delay";
        case BOOMERANG_STATE.RETURNING:
          return "Returning";
      }
    }

    GetScriptInterfaceClass() {
      return scriptInterface;
    }
  };
}


B_C.Instance = getInstanceJs(
  C3.SDKBehaviorInstanceBase,
  scriptInterface,
  addonTriggers,
  C3
);
